use 5.6.0;
use strict;
#------------------------------------------------------------------------------
# OAuth⥸塼
#						(C)2010 nabe / nabe@abk
#------------------------------------------------------------------------------
# HMAC-SHA1 
#
package Satsuki::Base::OAuth;
our $VERSION   = '0.10';
###############################################################################
# ܽ
###############################################################################
#------------------------------------------------------------------------------
# ڥ󥹥ȥ饯
#------------------------------------------------------------------------------
sub new {
	my $class = shift;
	my $self = {};		# 
	bless($self, $class);	# $self 򤳤Υ饹ȴϢդ

	my $ROBJ = shift;
	$self->{ROBJ} = $ROBJ;
	$self->{oauth_ver} = "1.0";
	$self->{signature_method} = 'HMAC-SHA1';
	return $self;
}

###############################################################################
# ᥤ롼
###############################################################################
#------------------------------------------------------------------------------
# ꥵФ˥ꥯȤ
#------------------------------------------------------------------------------
sub request_token {
	my $self = shift;
	my $h = shift;
	my $ROBJ = $self->{ROBJ};

	my $nonce = $self->generate_nonce();
	my $msg = "oauth_consumer_key=$h->{consumer_key}"
		. "&oauth_nonce=$nonce"
		. "&oauth_signature_method=$self->{signature_method}"
		. "&oauth_timestamp=$ROBJ->{TM}"
		. "&oauth_version=$self->{oauth_ver}"
		;
	my $sig = $self->generate_signature('POST', $h->{request_token_path}, $msg, $h->{consumer_secret});

	my $add_header=<<TEXT;
Authorization: OAuth realm="$h->{realm}",
 oauth_consumer_key="$h->{consumer_key}",
 oauth_nonce="$nonce",
 oauth_signature="$sig",
 oauth_signature_method="$self->{signature_method}",
 oauth_timestamp="$ROBJ->{TM}",
 oauth_version="$self->{oauth_ver}"
TEXT

	my $http = $ROBJ->loadpm('Base::HTTP');
	$http->{error_to_root} = 1;
	my $res = $http->do_get($h->{request_token_path}, {}, $add_header);

	if (!ref($res)) { return undef; }	# error
	my $res = $self->parse_response( join('', @$res) );
	if ($res->{oauth_callback_confirmed} ne 'true') {
		$ROBJ->error("OAuth request_token response error\n");
		return undef;
	}
	return $res;
}

#------------------------------------------------------------------------------
# ǧQuery
#------------------------------------------------------------------------------
sub request_access_token {
	my $self = shift;
	my $h = shift;
	my $ROBJ = $self->{ROBJ};

	my $nonce = $self->generate_nonce();
	my $msg = "oauth_consumer_key=$h->{consumer_key}"
		. "&oauth_nonce=$nonce"
		. "&oauth_signature_method=$self->{signature_method}"
		. "&oauth_timestamp=$ROBJ->{TM}"
		. "&oauth_token=$h->{token}"
		. "&oauth_verifier=$h->{verifier}"
		. "&oauth_version=$self->{oauth_ver}"
		;
	my $sig = $self->generate_signature('POST', $h->{access_token_path}, $msg,
		$h->{consumer_secret}, $h->{token_secret});

	my $add_header=<<TEXT;
Authorization: OAuth realm="$h->{realm}",
 oauth_consumer_key="$h->{consumer_key}",
 oauth_nonce="$nonce",
 oauth_signature="$sig",
 oauth_signature_method="$self->{signature_method}",
 oauth_timestamp="$ROBJ->{TM}",
 oauth_token="$h->{token}",
 oauth_verifier="$h->{verifier}",
 oauth_version="$self->{oauth_ver}"
TEXT
	my $http = $ROBJ->loadpm('Base::HTTP');
	$http->{error_to_root} = 1;
	my $res = $http->do_get($h->{access_token_path}, {}, $add_header);

	if (!ref($res)) { return undef; }	# error
	return $self->parse_response( join('', @$res) );
}

#------------------------------------------------------------------------------
# ǧQuery
#------------------------------------------------------------------------------
# status ΤбΤäĤ͡
sub status_update {
	my $self = shift;
	my ($h, $url, $req) = @_;
	my $ROBJ = $self->{ROBJ};

#  GET /photos?file=vacation.jpg&size=original HTTP/1.1
#  Host: photos.example.net
#  Authorization: OAuth realm="Photos",
#     oauth_consumer_key="dpf43f3p2l4k3l03",
#     oauth_token="nnch734d00sl2jdk",
#     oauth_signature_method="HMAC-SHA1",
#     oauth_timestamp="137131202",
#     oauth_nonce="chapoH",
#     oauth_signature="MdpQcU8iPSUjWoN%2FUDMsK2sui9I%3D"

	my $status = $req->{status};
	my $jcode = $ROBJ->loadpm('Jcode');	# ܸѴWrapper
	$status = $jcode->from_to(\$status, $ROBJ->{System_coding}, 'UTF-8');
	$req->{status} = $status;

	$self->urlencode($status);
	my $nonce = $self->generate_nonce();
	my $msg = "oauth_consumer_key=$h->{consumer_key}"
		. "&oauth_nonce=$nonce"
		. "&oauth_signature_method=$self->{signature_method}"
		. "&oauth_timestamp=$ROBJ->{TM}"
		. "&oauth_token=$h->{access_token}"
		. "&oauth_version=$self->{oauth_ver}"
		. "&status=$status"
		;
	my $sig = $self->generate_signature('POST', $url, $msg,
		$h->{consumer_secret}, $h->{access_token_secret});

	my $add_header=<<TEXT;
Authorization: OAuth realm="$h->{realm}",
 oauth_consumer_key="$h->{consumer_key}",
 oauth_nonce="$nonce",
 oauth_signature="$sig",
 oauth_signature_method="$self->{signature_method}",
 oauth_timestamp="$ROBJ->{TM}",
 oauth_token="$h->{access_token}",
 oauth_version="$self->{oauth_ver}"
TEXT

	my $http = $ROBJ->loadpm('Base::HTTP');
	$http->{error_to_root} = 1;
	my $res = $http->do_get($url, $req, $add_header);

	if (!ref($res)) { return undef; }	# error
	return $self->parse_response( join('', @$res) );
}

###############################################################################
# ֥롼
###############################################################################
#------------------------------------------------------------------------------
# http://:xxx/ Υѡ
#------------------------------------------------------------------------------
sub parse_host_path {
	my $self = shift;
	my $url = shift;
	if ($url !~ m|^http://([^/:]*)(?::(\d+))?(.*)$|) {
		return undef;
	}
	return ($1, $3);
}

#------------------------------------------------------------------------------
# nonce
#------------------------------------------------------------------------------
sub generate_nonce {
	my ($self) = @_;
	my $salt = $self->{ROBJ}->{Salt64chars};
	my $nonce;
	my $base = $ENV{UNIQUE_ID} . $ENV{REMOTE_ADDR};
	for(my $i=0; $i<20; $i++) {
		$nonce .= substr($salt, int(rand(256+ord(substr($base,$i,1))*256) % 64), 1);
	}
	$nonce =~ s/[^\w\-]//g;
	return $nonce;
}

#------------------------------------------------------------------------------
# HMAC-SHA1
#------------------------------------------------------------------------------
sub hmac_sha1 {
	my $self = shift;
	my ($key, $msg) = @_;
	my $sha1;
	if ($Digest::SHA::PurePerl::VERSION) {
		$sha1 = Digest::SHA::PurePerl->new(1);
	} else {
		eval {
			require Digest::SHA1;
			$sha1 = Digest::SHA1->new;
		};
		if ($@) {
			require Digest::SHA::PurePerl;
			$sha1 = Digest::SHA::PurePerl->new(1);
		}
	}

	my $bs = 64;
	if (length($key) > $bs) {
		$key = $sha1->add($key)->digest;
		$sha1->reset;
	}
	my $k_opad = $key ^ ("\x5c" x $bs);
	my $k_ipad = $key ^ ("\x36" x $bs);
	$sha1->add($k_ipad);
	$sha1->add($msg);
	my $hk_ipad = $sha1->digest;
	$sha1->reset;
	$sha1->add($k_opad, $hk_ipad);

	my $b64d = $sha1->b64digest;
	$b64d = substr($b64d.'====', 0, ((length($b64d)+3)>>2)<<2);
	return $b64d;
}

#------------------------------------------------------------------------------
# URI󥳡
#------------------------------------------------------------------------------
sub urlencode {
	my $self = shift;
	foreach(@_) {
		$_ =~ s|([^a-zA-Z0-9\-\._\~])|
			my $x = '%' . unpack('H2', $1);
			$x =~ tr/a-f/A-F/;
			$x;
		|eg;
	}
}

#------------------------------------------------------------------------------
# ̾
#------------------------------------------------------------------------------
sub generate_signature {
	my $self = shift;
	my ($method, $url, $msg, $secret1, $secret2) = @_;

	# signature
	$self->urlencode($url, $msg);
	my $sig = $self->hmac_sha1("$secret1&$secret2", "$method&$url&$msg");
	$sig =~ s/=/%3D/g;
	return $sig;
}
#------------------------------------------------------------------------------
# 쥹ݥ󥹤Υѡ
#------------------------------------------------------------------------------
sub parse_response {
	my $self = shift;
	my @ary = split(/&/, shift);
	my %h;
	foreach (@ary) {
		my ($k, $v) = split(/=/, $_, 2);
		$v =~ tr/+/ /;
		$v =~ s/%([0-9a-fA-F][0-9a-fA-F])/chr(hex($1))/eg;
		$v =~ s/[\x00-\x08\x0b\x0c\x0e-\x1f\x7f]//g;	# TAB LF CRʳ楳ɤ
		$h{$k} = $v;
	}
	return \%h;
}

###############################################################################
# 顼
###############################################################################
sub debug {
	my $self = shift;
	$self->{ROBJ}->debug(@_);	# debug-safe
}

1;
